Statistics
| Branch: | Tag: | Revision:

root / Makefile.am @ aa3adf35

History | View | Annotate | Download (40.3 kB)

1 e8230860 Michael Hanselmann
# Ganeti makefile
2 e8230860 Michael Hanselmann
# - Indent with tabs only.
3 e8230860 Michael Hanselmann
# - Keep files sorted; one line per file.
4 e8230860 Michael Hanselmann
# - Directories in lib/ must have their own *dir variable (see hypervisor).
5 e8230860 Michael Hanselmann
# - All directories must be listed DIRS.
6 0a7bed64 Michael Hanselmann
# - Use autogen.sh to generate Makefile.in and configure script.
7 e8230860 Michael Hanselmann
8 e8230860 Michael Hanselmann
# Automake doesn't export these variables before version 1.10.
9 e8230860 Michael Hanselmann
abs_top_builddir = @abs_top_builddir@
10 e8230860 Michael Hanselmann
abs_top_srcdir = @abs_top_srcdir@
11 e8230860 Michael Hanselmann
12 08366664 Michael Hanselmann
# Helper values for calling builtin functions
13 08366664 Michael Hanselmann
empty :=
14 08366664 Michael Hanselmann
space := $(empty) $(empty)
15 08366664 Michael Hanselmann
comma := ,
16 08366664 Michael Hanselmann
17 a01dd3c6 Iustin Pop
# Use bash in order to be able to use pipefail
18 a01dd3c6 Iustin Pop
SHELL=/bin/bash
19 a01dd3c6 Iustin Pop
20 6e06b36c Iustin Pop
ACLOCAL_AMFLAGS = -I autotools
21 4f3d5b76 Michael Hanselmann
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 b959138f Michael Hanselmann
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 eed5c5df Michael Hanselmann
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 5d3c30df Michael Hanselmann
CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 c55cc346 Iustin Pop
CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 73d0e218 Iustin Pop
CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 96602be4 Michael Hanselmann
CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 7385c51d Michael Hanselmann
CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 f6cbcc06 Michael Hanselmann
CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 95eb4188 Michael Hanselmann
DOCPP = $(top_srcdir)/autotools/docpp
31 e8230860 Michael Hanselmann
REPLACE_VARS_SED = autotools/replace_vars.sed
32 d99d1e36 Iustin Pop
CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 d5a2a550 Michael Hanselmann
BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 e8230860 Michael Hanselmann
35 22c5390d Iustin Pop
# Note: these are automake-specific variables, and must be named after
36 22c5390d Iustin Pop
# the directory + 'dir' suffix
37 2d48a3a2 Michael Hanselmann
clientdir = $(pkgpythondir)/client
38 e8230860 Michael Hanselmann
hypervisordir = $(pkgpythondir)/hypervisor
39 ff9efc03 Michael Hanselmann
httpdir = $(pkgpythondir)/http
40 dc101ecc Michael Hanselmann
masterddir = $(pkgpythondir)/masterd
41 12426ae1 Guido Trotter
confddir = $(pkgpythondir)/confd
42 8c229cc7 Oleksiy Mishchenko
rapidir = $(pkgpythondir)/rapi
43 899c4d2c Michael Hanselmann
serverdir = $(pkgpythondir)/server
44 9f4bb951 Michael Hanselmann
watcherdir = $(pkgpythondir)/watcher
45 bb44b1ae Michael Hanselmann
impexpddir = $(pkgpythondir)/impexpd
46 c047a981 Michael Hanselmann
utilsdir = $(pkgpythondir)/utils
47 e8230860 Michael Hanselmann
toolsdir = $(pkglibdir)/tools
48 7617fd6b Iustin Pop
iallocatorsdir = $(pkglibdir)/iallocators
49 0d2bf835 René Nussbaumer
pytoolsdir = $(pkgpythondir)/tools
50 e8230860 Michael Hanselmann
docdir = $(datadir)/doc/$(PACKAGE)
51 b8fe7ca6 Iustin Pop
myexeclibdir = $(pkglibdir)
52 e8230860 Michael Hanselmann
53 a4f12da4 Michael Hanselmann
# Delete output file if an error occurred while building it
54 a4f12da4 Michael Hanselmann
.DELETE_ON_ERROR:
55 a4f12da4 Michael Hanselmann
56 d5506465 Iustin Pop
HTOOLS_DIRS = \
57 d5506465 Iustin Pop
	htools \
58 d5506465 Iustin Pop
	htools/Ganeti \
59 358a0a8f Iustin Pop
	htools/Ganeti/Confd \
60 458a286a Iustin Pop
	htools/Ganeti/HTools \
61 458a286a Iustin Pop
	htools/Ganeti/HTools/Program
62 d5506465 Iustin Pop
63 e8230860 Michael Hanselmann
DIRS = \
64 e8230860 Michael Hanselmann
	autotools \
65 e8230860 Michael Hanselmann
	daemons \
66 e8230860 Michael Hanselmann
	devel \
67 e8230860 Michael Hanselmann
	doc \
68 e8230860 Michael Hanselmann
	doc/examples \
69 d6d9ce45 Guido Trotter
	doc/examples/hooks \
70 c51580b3 Guido Trotter
	doc/examples/gnt-debug \
71 d5506465 Iustin Pop
	$(HTOOLS_DIRS) \
72 e8230860 Michael Hanselmann
	lib \
73 2d48a3a2 Michael Hanselmann
	lib/client \
74 f9897b6d Michael Hanselmann
	lib/build \
75 2f16ea8f Michael Hanselmann
	lib/confd \
76 ff9efc03 Michael Hanselmann
	lib/http \
77 e8230860 Michael Hanselmann
	lib/hypervisor \
78 bb44b1ae Michael Hanselmann
	lib/impexpd \
79 dc101ecc Michael Hanselmann
	lib/masterd \
80 8c229cc7 Oleksiy Mishchenko
	lib/rapi \
81 899c4d2c Michael Hanselmann
	lib/server \
82 0d2bf835 René Nussbaumer
	lib/tools \
83 c047a981 Michael Hanselmann
	lib/utils \
84 9f4bb951 Michael Hanselmann
	lib/watcher \
85 e8230860 Michael Hanselmann
	man \
86 e8230860 Michael Hanselmann
	qa \
87 e8230860 Michael Hanselmann
	test \
88 e8230860 Michael Hanselmann
	test/data \
89 6bbd76d2 Iustin Pop
	test/data/htools \
90 91e5a351 Iustin Pop
	test/data/htools/rapi \
91 1e6fab60 Agata Murawska
	test/data/ovfdata \
92 d92518d3 Agata Murawska
	test/data/ovfdata/other \
93 e8230860 Michael Hanselmann
	tools
94 e8230860 Michael Hanselmann
95 2750b299 Michael Hanselmann
BUILDTIME_DIR_AUTOCREATE = \
96 c964d962 Michael Hanselmann
	scripts \
97 22c5390d Iustin Pop
	$(APIDOC_DIR) \
98 22c5390d Iustin Pop
	$(APIDOC_PY_DIR) \
99 22c5390d Iustin Pop
	$(APIDOC_HS_DIR) \
100 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti \
101 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Confd \
102 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools \
103 458a286a Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools/Program \
104 22c5390d Iustin Pop
	$(COVERAGE_DIR) \
105 22c5390d Iustin Pop
	$(COVERAGE_PY_DIR) \
106 22c5390d Iustin Pop
	$(COVERAGE_HS_DIR) \
107 b91e9518 Iustin Pop
	.hpc
108 2750b299 Michael Hanselmann
109 2750b299 Michael Hanselmann
BUILDTIME_DIRS = \
110 2750b299 Michael Hanselmann
	$(BUILDTIME_DIR_AUTOCREATE) \
111 6b997854 Michael Hanselmann
	doc/html
112 6b997854 Michael Hanselmann
113 6b997854 Michael Hanselmann
DIRCHECK_EXCLUDE = \
114 6b997854 Michael Hanselmann
	$(BUILDTIME_DIRS) \
115 6b997854 Michael Hanselmann
	ganeti-[0-9]*.[0-9]*.[0-9]* \
116 6b997854 Michael Hanselmann
	doc/html/_*
117 6b997854 Michael Hanselmann
118 2750b299 Michael Hanselmann
all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
119 c964d962 Michael Hanselmann
120 22c5390d Iustin Pop
# some helper vars
121 22c5390d Iustin Pop
COVERAGE_DIR = doc/coverage
122 22c5390d Iustin Pop
COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
123 22c5390d Iustin Pop
COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
124 22c5390d Iustin Pop
APIDOC_DIR = doc/api
125 22c5390d Iustin Pop
APIDOC_PY_DIR = $(APIDOC_DIR)/py
126 22c5390d Iustin Pop
APIDOC_HS_DIR = $(APIDOC_DIR)/hs
127 22c5390d Iustin Pop
128 2ab2b9f5 Iustin Pop
MAINTAINERCLEANFILES = \
129 d17e74b4 Iustin Pop
	$(docpng) \
130 b76aac08 Michael Hanselmann
	$(maninput) \
131 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
132 84a12e40 Iustin Pop
	doc/news.rst \
133 7a03d293 Michael Hanselmann
	doc/upgrade.rst \
134 84a12e40 Iustin Pop
	vcs-version
135 2ab2b9f5 Iustin Pop
136 d17e74b4 Iustin Pop
maintainer-clean-local:
137 6b997854 Michael Hanselmann
	rm -rf $(BUILDTIME_DIRS)
138 d17e74b4 Iustin Pop
139 e8230860 Michael Hanselmann
CLEANFILES = \
140 2f16ea8f Michael Hanselmann
	$(addsuffix /*.py[co],$(DIRS)) \
141 d5506465 Iustin Pop
	$(addsuffix /*.hi,$(HTOOLS_DIRS)) \
142 d5506465 Iustin Pop
	$(addsuffix /*.o,$(HTOOLS_DIRS)) \
143 c964d962 Michael Hanselmann
	$(all_dirfiles) \
144 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
145 f774bd03 Michael Hanselmann
	epydoc.conf \
146 e8230860 Michael Hanselmann
	autotools/replace_vars.sed \
147 f154a7a3 Michael Hanselmann
	daemons/daemon-util \
148 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner \
149 e8230860 Michael Hanselmann
	devel/upload \
150 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
151 f72f8622 Iustin Pop
	doc/examples/bash_completion \
152 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py \
153 2ab2b9f5 Iustin Pop
	$(man_MANS) \
154 2ab2b9f5 Iustin Pop
	$(manhtml) \
155 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
156 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
157 d6159933 Iustin Pop
	$(nodist_pkgpython_PYTHON) \
158 c3f67183 Iustin Pop
	$(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
159 191ff68c Iustin Pop
	.hpc/*.mix htools/*.tix \
160 191ff68c Iustin Pop
	doc/hs-lint.html
161 e8230860 Michael Hanselmann
162 c964d962 Michael Hanselmann
# BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
163 c964d962 Michael Hanselmann
# it'll cause the target to rebuild every time.
164 dc7d2c49 Michael Hanselmann
BUILT_SOURCES = \
165 96a7481d Michael Hanselmann
  $(built_base_sources) \
166 96a7481d Michael Hanselmann
	$(BUILT_PYTHON_SOURCES) \
167 96a7481d Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
168 96a7481d Michael Hanselmann
169 96a7481d Michael Hanselmann
built_base_sources = \
170 dc7d2c49 Michael Hanselmann
	ganeti \
171 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
172 96a7481d Michael Hanselmann
	$(all_dirfiles)
173 2d1f248e Michael Hanselmann
174 96a7481d Michael Hanselmann
built_python_base_sources = \
175 13aeae6a Iustin Pop
	lib/_autoconf.py \
176 96a7481d Michael Hanselmann
	lib/_vcsversion.py
177 96a7481d Michael Hanselmann
178 96a7481d Michael Hanselmann
BUILT_PYTHON_SOURCES = \
179 96a7481d Michael Hanselmann
	$(built_python_base_sources) \
180 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py
181 e8230860 Michael Hanselmann
182 96a7481d Michael Hanselmann
# Generating the RPC wrappers depends on many things, so make sure it's built at
183 96a7481d Michael Hanselmann
# the end of the built sources
184 96a7481d Michael Hanselmann
lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
185 96a7481d Michael Hanselmann
186 656a7fdf Iustin Pop
# these are all built from the underlying %.in sources
187 656a7fdf Iustin Pop
BUILT_EXAMPLES = \
188 656a7fdf Iustin Pop
	doc/examples/ganeti-kvm-poweroff.initd \
189 656a7fdf Iustin Pop
	doc/examples/ganeti.cron \
190 656a7fdf Iustin Pop
	doc/examples/ganeti.initd \
191 656a7fdf Iustin Pop
	doc/examples/gnt-config-backup \
192 656a7fdf Iustin Pop
	doc/examples/hooks/ipsec
193 656a7fdf Iustin Pop
194 08366664 Michael Hanselmann
nodist_pkgpython_PYTHON = \
195 08366664 Michael Hanselmann
	$(BUILT_PYTHON_SOURCES)
196 08366664 Michael Hanselmann
197 f9897b6d Michael Hanselmann
noinst_PYTHON = \
198 5f43f393 Michael Hanselmann
	lib/build/__init__.py \
199 5f43f393 Michael Hanselmann
	lib/build/sphinx_ext.py
200 f9897b6d Michael Hanselmann
201 e8230860 Michael Hanselmann
pkgpython_PYTHON = \
202 e8230860 Michael Hanselmann
	lib/__init__.py \
203 a8a76bc2 Guido Trotter
	lib/asyncnotifier.py \
204 e8230860 Michael Hanselmann
	lib/backend.py \
205 e8230860 Michael Hanselmann
	lib/bdev.py \
206 e8230860 Michael Hanselmann
	lib/bootstrap.py \
207 e8230860 Michael Hanselmann
	lib/cli.py \
208 e8230860 Michael Hanselmann
	lib/cmdlib.py \
209 cea881e5 Michael Hanselmann
	lib/compat.py \
210 e8230860 Michael Hanselmann
	lib/config.py \
211 e8230860 Michael Hanselmann
	lib/constants.py \
212 821d9e43 Michael Hanselmann
	lib/daemon.py \
213 e8230860 Michael Hanselmann
	lib/errors.py \
214 62e0e880 Iustin Pop
	lib/ht.py \
215 e8230860 Michael Hanselmann
	lib/jqueue.py \
216 8b537bb0 Michael Hanselmann
	lib/jstore.py \
217 e8230860 Michael Hanselmann
	lib/locking.py \
218 e8230860 Michael Hanselmann
	lib/luxi.py \
219 e8230860 Michael Hanselmann
	lib/mcpu.py \
220 a744b676 Manuel Franceschini
	lib/netutils.py \
221 e8230860 Michael Hanselmann
	lib/objects.py \
222 e8230860 Michael Hanselmann
	lib/opcodes.py \
223 ced78a66 Agata Murawska
	lib/ovf.py \
224 a123dc19 Michael Hanselmann
	lib/qlang.py \
225 4ca96421 Michael Hanselmann
	lib/query.py \
226 e8230860 Michael Hanselmann
	lib/rpc.py \
227 6648cb36 Michael Hanselmann
	lib/rpc_defs.py \
228 f12e1736 René Nussbaumer
	lib/runtime.py \
229 e8230860 Michael Hanselmann
	lib/serializer.py \
230 e8230860 Michael Hanselmann
	lib/ssconf.py \
231 e8230860 Michael Hanselmann
	lib/ssh.py \
232 ac2d0fe4 Michael Hanselmann
	lib/storage.py \
233 1338f2b4 Balazs Lecz
	lib/uidpool.py \
234 76094e37 Michael Hanselmann
	lib/workerpool.py
235 e8230860 Michael Hanselmann
236 2d48a3a2 Michael Hanselmann
client_PYTHON = \
237 c2855a12 Michael Hanselmann
	lib/client/__init__.py \
238 02266fe0 Michael Hanselmann
	lib/client/gnt_backup.py \
239 7b3e7d41 Michael Hanselmann
	lib/client/gnt_cluster.py \
240 6d50f5f9 Michael Hanselmann
	lib/client/gnt_debug.py \
241 667dbd6b Adeodato Simo
	lib/client/gnt_group.py \
242 e792102d Michael Hanselmann
	lib/client/gnt_instance.py \
243 a09b9e3d Michael Hanselmann
	lib/client/gnt_job.py \
244 37494fa4 Michael Hanselmann
	lib/client/gnt_node.py \
245 6d50f5f9 Michael Hanselmann
	lib/client/gnt_os.py
246 2d48a3a2 Michael Hanselmann
247 e8230860 Michael Hanselmann
hypervisor_PYTHON = \
248 e8230860 Michael Hanselmann
	lib/hypervisor/__init__.py \
249 e8230860 Michael Hanselmann
	lib/hypervisor/hv_base.py \
250 48297fa2 Iustin Pop
	lib/hypervisor/hv_chroot.py \
251 e8230860 Michael Hanselmann
	lib/hypervisor/hv_fake.py \
252 eb58f9b1 Guido Trotter
	lib/hypervisor/hv_kvm.py \
253 4b5e40a5 Iustin Pop
	lib/hypervisor/hv_lxc.py \
254 e8230860 Michael Hanselmann
	lib/hypervisor/hv_xen.py
255 e8230860 Michael Hanselmann
256 8c229cc7 Oleksiy Mishchenko
rapi_PYTHON = \
257 8c229cc7 Oleksiy Mishchenko
	lib/rapi/__init__.py \
258 10b207d4 Oleksiy Mishchenko
	lib/rapi/baserlib.py \
259 95ab4de9 David Knowles
	lib/rapi/client.py \
260 20b509de Michael Hanselmann
	lib/rapi/client_utils.py \
261 10b207d4 Oleksiy Mishchenko
	lib/rapi/connector.py \
262 a85f23fa Michael Hanselmann
	lib/rapi/rlib2.py \
263 a85f23fa Michael Hanselmann
	lib/rapi/testutils.py
264 8c229cc7 Oleksiy Mishchenko
265 ff9efc03 Michael Hanselmann
http_PYTHON = \
266 02cab3e7 Michael Hanselmann
	lib/http/__init__.py \
267 be500c29 Michael Hanselmann
	lib/http/auth.py \
268 02cab3e7 Michael Hanselmann
	lib/http/client.py \
269 02cab3e7 Michael Hanselmann
	lib/http/server.py
270 ff9efc03 Michael Hanselmann
271 12426ae1 Guido Trotter
confd_PYTHON = \
272 71f27d19 Guido Trotter
	lib/confd/__init__.py \
273 e4ccf6cd Guido Trotter
	lib/confd/client.py \
274 2f16ea8f Michael Hanselmann
	lib/confd/querylib.py \
275 2f16ea8f Michael Hanselmann
	lib/confd/server.py
276 8c229cc7 Oleksiy Mishchenko
277 dc101ecc Michael Hanselmann
masterd_PYTHON = \
278 033a1d00 Michael Hanselmann
	lib/masterd/__init__.py \
279 033a1d00 Michael Hanselmann
	lib/masterd/instance.py
280 dc101ecc Michael Hanselmann
281 bb44b1ae Michael Hanselmann
impexpd_PYTHON = \
282 bb44b1ae Michael Hanselmann
	lib/impexpd/__init__.py
283 bb44b1ae Michael Hanselmann
284 9f4bb951 Michael Hanselmann
watcher_PYTHON = \
285 9ca87fb3 Michael Hanselmann
	lib/watcher/__init__.py \
286 adf6301e Michael Hanselmann
	lib/watcher/nodemaint.py \
287 adf6301e Michael Hanselmann
	lib/watcher/state.py
288 9f4bb951 Michael Hanselmann
289 899c4d2c Michael Hanselmann
server_PYTHON = \
290 29d91329 Michael Hanselmann
	lib/server/__init__.py \
291 5c9c0e0e Michael Hanselmann
	lib/server/confd.py \
292 5119f2ec Michael Hanselmann
	lib/server/masterd.py \
293 d9c82a4e Michael Hanselmann
	lib/server/noded.py \
294 d9c82a4e Michael Hanselmann
	lib/server/rapi.py
295 899c4d2c Michael Hanselmann
296 0d2bf835 René Nussbaumer
pytools_PYTHON = \
297 0d2bf835 René Nussbaumer
	lib/tools/__init__.py \
298 0d2bf835 René Nussbaumer
	lib/tools/ensure_dirs.py
299 0d2bf835 René Nussbaumer
300 c047a981 Michael Hanselmann
utils_PYTHON = \
301 4fd029cf Michael Hanselmann
	lib/utils/__init__.py \
302 79d22269 Michael Hanselmann
	lib/utils/algo.py \
303 9d1b963f Michael Hanselmann
	lib/utils/filelock.py \
304 f21bb4b7 Michael Hanselmann
	lib/utils/hash.py \
305 3865ca48 Michael Hanselmann
	lib/utils/io.py \
306 1ae4c5a1 Michael Hanselmann
	lib/utils/log.py \
307 8dc76d54 Guido Trotter
	lib/utils/mlock.py \
308 17b97ab3 Michael Hanselmann
	lib/utils/nodesetup.py \
309 a4ccecf6 Michael Hanselmann
	lib/utils/process.py \
310 7fcffe27 Michael Hanselmann
	lib/utils/retry.py \
311 7831fc5f Michael Hanselmann
	lib/utils/text.py \
312 c50645c0 Michael Hanselmann
	lib/utils/wrapper.py \
313 c50645c0 Michael Hanselmann
	lib/utils/x509.py
314 c047a981 Michael Hanselmann
315 f05c99f3 Michael Hanselmann
docrst = \
316 ffa6869f Iustin Pop
	doc/admin.rst \
317 5c0c1eeb Iustin Pop
	doc/design-2.0.rst \
318 4f366caf Michael Hanselmann
	doc/design-2.1.rst \
319 e56bb0e8 Guido Trotter
	doc/design-2.2.rst \
320 1eb85930 Guido Trotter
	doc/design-2.3.rst \
321 92902e91 Iustin Pop
	doc/design-htools-2.3.rst \
322 78b40c5e Michael Hanselmann
	doc/design-2.4.rst \
323 d774ce92 Michael Hanselmann
	doc/design-2.5.rst \
324 c95c0f71 Michael Hanselmann
	doc/design-draft.rst \
325 1e86ee97 Marc Schmitt
	doc/design-oob.rst \
326 ae9b5e0f Tsachy Shacham
	doc/design-cpu-pinning.rst \
327 e5a246df Michael Hanselmann
	doc/design-query2.rst \
328 539f195a Michael Hanselmann
	doc/design-x509-ca.rst \
329 278ddaa9 Michael Hanselmann
	doc/design-http-server.rst \
330 1375e1d9 Michael Hanselmann
	doc/design-impexp2.rst \
331 ed9fda24 Michael Hanselmann
	doc/design-lu-generated-jobs.rst \
332 4055b109 Adeodato Simo
	doc/design-multi-reloc.rst \
333 eec83a95 Apollon Oikonomopoulos
	doc/design-network.rst \
334 6c3d18e0 Michael Hanselmann
	doc/design-chained-jobs.rst \
335 64ea845e Michael Hanselmann
	doc/design-ovf-support.rst \
336 d85f01e7 Iustin Pop
	doc/design-resource-model.rst \
337 d9bdffc3 René Nussbaumer
	doc/cluster-merge.rst \
338 a997cec5 Apollon Oikonomopoulos
	doc/design-shared-storage.rst \
339 23f0b93e René Nussbaumer
	doc/design-node-state-cache.rst \
340 6b898285 Iustin Pop
	doc/design-virtual-clusters.rst \
341 62947ebb Michael Hanselmann
	doc/devnotes.rst \
342 e2078d28 Iustin Pop
	doc/glossary.rst \
343 4d6443f4 Iustin Pop
	doc/hooks.rst \
344 876860a3 Iustin Pop
	doc/iallocator.rst \
345 d17e74b4 Iustin Pop
	doc/index.rst \
346 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
347 28e15341 Iustin Pop
	doc/install.rst \
348 9725b53d Michael Hanselmann
	doc/locking.rst \
349 6bf273d5 Michael Hanselmann
	doc/move-instance.rst \
350 c71a1a3d Iustin Pop
	doc/news.rst \
351 6d81475c Iustin Pop
	doc/rapi.rst \
352 b76aac08 Michael Hanselmann
	doc/security.rst \
353 35dd762d Michael Hanselmann
	doc/upgrade.rst \
354 c71a1a3d Iustin Pop
	doc/walkthrough.rst
355 f05c99f3 Michael Hanselmann
356 3c899290 Iustin Pop
HS_PROGS = htools/htools htools/hconfd
357 2922d2c5 René Nussbaumer
HS_BIN_ROLES = hbal hscan hspace hinfo
358 d6159933 Iustin Pop
359 896b2850 Iustin Pop
HS_ALL_PROGS = $(HS_PROGS) htools/test htools/hpc-htools
360 c3f67183 Iustin Pop
HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
361 d6159933 Iustin Pop
# we don't add -Werror by default
362 d5506465 Iustin Pop
HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
363 b91e9518 Iustin Pop
# extra flags that can be overriden on the command line
364 d6159933 Iustin Pop
HEXTRA =
365 c7ec3025 Iustin Pop
# internal extra flags (used for htools/test mainly)
366 c7ec3025 Iustin Pop
HEXTRA_INT =
367 b91e9518 Iustin Pop
# exclude options for coverage reports
368 9822b1dd Iustin Pop
HPCEXCL = --exclude Main \
369 98b33d0e Iustin Pop
	--exclude Ganeti.Constants \
370 9822b1dd Iustin Pop
	--exclude Ganeti.THH \
371 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QC \
372 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QCHelper \
373 98b33d0e Iustin Pop
	--exclude Ganeti.HTools.Version
374 d6159933 Iustin Pop
375 c3f67183 Iustin Pop
HS_LIB_SRCS = \
376 d6159933 Iustin Pop
	htools/Ganeti/HTools/CLI.hs \
377 d6159933 Iustin Pop
	htools/Ganeti/HTools/Cluster.hs \
378 1adec4be Iustin Pop
	htools/Ganeti/HTools/Compat.hs \
379 d6159933 Iustin Pop
	htools/Ganeti/HTools/Container.hs \
380 d6159933 Iustin Pop
	htools/Ganeti/HTools/ExtLoader.hs \
381 d6159933 Iustin Pop
	htools/Ganeti/HTools/Group.hs \
382 d6159933 Iustin Pop
	htools/Ganeti/HTools/IAlloc.hs \
383 d6159933 Iustin Pop
	htools/Ganeti/HTools/Instance.hs \
384 f047f90f Iustin Pop
	htools/Ganeti/HTools/JSON.hs \
385 d6159933 Iustin Pop
	htools/Ganeti/HTools/Loader.hs \
386 d6159933 Iustin Pop
	htools/Ganeti/HTools/Luxi.hs \
387 d6159933 Iustin Pop
	htools/Ganeti/HTools/Node.hs \
388 d6159933 Iustin Pop
	htools/Ganeti/HTools/PeerMap.hs \
389 d6159933 Iustin Pop
	htools/Ganeti/HTools/QC.hs \
390 9822b1dd Iustin Pop
	htools/Ganeti/HTools/QCHelper.hs \
391 d6159933 Iustin Pop
	htools/Ganeti/HTools/Rapi.hs \
392 d6159933 Iustin Pop
	htools/Ganeti/HTools/Simu.hs \
393 d6159933 Iustin Pop
	htools/Ganeti/HTools/Text.hs \
394 d6159933 Iustin Pop
	htools/Ganeti/HTools/Types.hs \
395 d6159933 Iustin Pop
	htools/Ganeti/HTools/Utils.hs \
396 9f13be88 Iustin Pop
	htools/Ganeti/HTools/Program.hs \
397 458a286a Iustin Pop
	htools/Ganeti/HTools/Program/Hail.hs \
398 201b6c34 Iustin Pop
	htools/Ganeti/HTools/Program/Hbal.hs \
399 2922d2c5 René Nussbaumer
	htools/Ganeti/HTools/Program/Hinfo.hs \
400 7b695a0d Iustin Pop
	htools/Ganeti/HTools/Program/Hscan.hs \
401 1494a4cc Iustin Pop
	htools/Ganeti/HTools/Program/Hspace.hs \
402 0c37d1e4 Iustin Pop
	htools/Ganeti/BasicTypes.hs \
403 417cc253 Iustin Pop
	htools/Ganeti/Confd.hs \
404 358a0a8f Iustin Pop
	htools/Ganeti/Confd/Server.hs \
405 eaa64cd8 Iustin Pop
	htools/Ganeti/Config.hs \
406 6ec7a50e Iustin Pop
	htools/Ganeti/Daemon.hs \
407 21dc8694 Iustin Pop
	htools/Ganeti/Hash.hs \
408 d6159933 Iustin Pop
	htools/Ganeti/Jobs.hs \
409 ba4e38e8 Iustin Pop
	htools/Ganeti/Logging.hs \
410 d6159933 Iustin Pop
	htools/Ganeti/Luxi.hs \
411 b1e81520 Iustin Pop
	htools/Ganeti/Objects.hs \
412 e9aaa3c6 Iustin Pop
	htools/Ganeti/OpCodes.hs \
413 7946c25d Iustin Pop
	htools/Ganeti/Runtime.hs \
414 aa3adf35 Iustin Pop
	htools/Ganeti/Ssconf.hs \
415 e9aaa3c6 Iustin Pop
	htools/Ganeti/THH.hs
416 d6159933 Iustin Pop
417 d99d1e36 Iustin Pop
HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
418 c3f67183 Iustin Pop
HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
419 d6159933 Iustin Pop
420 c964d962 Michael Hanselmann
$(RUN_IN_TEMPDIR): | $(all_dirfiles)
421 c964d962 Michael Hanselmann
422 a2d917f3 Iustin Pop
# Note: we use here an order-only prerequisite, as the contents of
423 a2d917f3 Iustin Pop
# _autoconf.py are not actually influencing the html build output: it
424 a2d917f3 Iustin Pop
# has to exist in order for the sphinx module to be loaded
425 a2d917f3 Iustin Pop
# successfully, but we certainly don't want the docs to be rebuilt if
426 a2d917f3 Iustin Pop
# it changes
427 c964d962 Michael Hanselmann
doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
428 a2d917f3 Iustin Pop
	$(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
429 08366664 Michael Hanselmann
	| $(BUILT_PYTHON_SOURCES)
430 d17e74b4 Iustin Pop
	@test -n "$(SPHINX)" || \
431 d17e74b4 Iustin Pop
	    { echo 'sphinx-build' not found during configure; exit 1; }
432 2750b299 Michael Hanselmann
	@mkdir_p@ $(dir $@)
433 e7f6524c Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
434 13de7d59 Michael Hanselmann
	    -d . \
435 d17e74b4 Iustin Pop
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
436 d17e74b4 Iustin Pop
	    -D release="$(PACKAGE_VERSION)" \
437 13de7d59 Michael Hanselmann
	    $(abs_top_srcdir)/doc $(CURDIR)/doc/html
438 13de7d59 Michael Hanselmann
	rm -f doc/html/.buildinfo doc/html/objects.inv
439 13de7d59 Michael Hanselmann
	touch $@
440 13de7d59 Michael Hanselmann
441 c964d962 Michael Hanselmann
doc/html: doc/html/index.html
442 2ab2b9f5 Iustin Pop
443 cbf3d64b Michael Hanselmann
doc/install-quick.rst: INSTALL
444 b76aac08 Michael Hanselmann
doc/news.rst: NEWS
445 7a03d293 Michael Hanselmann
doc/upgrade.rst: UPGRADE
446 b76aac08 Michael Hanselmann
447 e8deef56 Michael Hanselmann
doc/install-quick.rst doc/news.rst doc/upgrade.rst:
448 cbf3d64b Michael Hanselmann
	set -e; \
449 cbf3d64b Michael Hanselmann
	{ echo '.. This file is automatically updated at build time from $<.'; \
450 cbf3d64b Michael Hanselmann
	  echo '.. Do not edit.'; \
451 cbf3d64b Michael Hanselmann
	  echo; \
452 cbf3d64b Michael Hanselmann
	  cat $<; \
453 cbf3d64b Michael Hanselmann
	} > $@
454 cbf3d64b Michael Hanselmann
455 b8195800 Iustin Pop
docdot = \
456 ca9ccea8 Michael Hanselmann
	doc/arch-2.0.dot \
457 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-acquire.dot \
458 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-release.dot
459 b8195800 Iustin Pop
460 d17e74b4 Iustin Pop
docpng = $(patsubst %.dot,%.png,$(docdot))
461 e8230860 Michael Hanselmann
462 7e1ccbe0 Michael Hanselmann
# Things to build but not to install (add it to EXTRA_DIST if it should be
463 7e1ccbe0 Michael Hanselmann
# distributed)
464 7e1ccbe0 Michael Hanselmann
noinst_DATA = \
465 7e1ccbe0 Michael Hanselmann
	devel/upload \
466 7e1ccbe0 Michael Hanselmann
	doc/html \
467 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
468 7e1ccbe0 Michael Hanselmann
	doc/examples/bash_completion \
469 7e1ccbe0 Michael Hanselmann
	$(manhtml)
470 f29266b4 Iustin Pop
471 4f3d5b76 Michael Hanselmann
gnt_scripts = \
472 e8230860 Michael Hanselmann
	scripts/gnt-backup \
473 e8230860 Michael Hanselmann
	scripts/gnt-cluster \
474 e8230860 Michael Hanselmann
	scripts/gnt-debug \
475 667dbd6b Adeodato Simo
	scripts/gnt-group \
476 e8230860 Michael Hanselmann
	scripts/gnt-instance \
477 e8230860 Michael Hanselmann
	scripts/gnt-job \
478 e8230860 Michael Hanselmann
	scripts/gnt-node \
479 e8230860 Michael Hanselmann
	scripts/gnt-os
480 e8230860 Michael Hanselmann
481 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP_SBIN = \
482 5c9c0e0e Michael Hanselmann
	daemons/ganeti-confd \
483 29d91329 Michael Hanselmann
	daemons/ganeti-masterd \
484 5119f2ec Michael Hanselmann
	daemons/ganeti-noded \
485 9f4bb951 Michael Hanselmann
	daemons/ganeti-watcher \
486 d9c82a4e Michael Hanselmann
	daemons/ganeti-rapi \
487 656a7fdf Iustin Pop
	$(gnt_scripts)
488 2d48a3a2 Michael Hanselmann
489 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP = \
490 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
491 0d2bf835 René Nussbaumer
	tools/ensure-dirs
492 0d2bf835 René Nussbaumer
493 a8c68e44 Michael Hanselmann
qa_scripts = \
494 a8c68e44 Michael Hanselmann
	qa/ganeti-qa.py \
495 a8c68e44 Michael Hanselmann
	qa/qa_cluster.py \
496 a8c68e44 Michael Hanselmann
	qa/qa_config.py \
497 a8c68e44 Michael Hanselmann
	qa/qa_daemon.py \
498 a8c68e44 Michael Hanselmann
	qa/qa_env.py \
499 a8c68e44 Michael Hanselmann
	qa/qa_error.py \
500 21bf2e2e Andrea Spadaccini
	qa/qa_group.py \
501 a8c68e44 Michael Hanselmann
	qa/qa_instance.py \
502 a8c68e44 Michael Hanselmann
	qa/qa_node.py \
503 a8c68e44 Michael Hanselmann
	qa/qa_os.py \
504 a8c68e44 Michael Hanselmann
	qa/qa_rapi.py \
505 a8c68e44 Michael Hanselmann
	qa/qa_tags.py \
506 a8c68e44 Michael Hanselmann
	qa/qa_utils.py
507 a8c68e44 Michael Hanselmann
508 d6159933 Iustin Pop
bin_SCRIPTS =
509 d6159933 Iustin Pop
if WANT_HTOOLS
510 c3f67183 Iustin Pop
bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
511 458a286a Iustin Pop
install-exec-hook:
512 458a286a Iustin Pop
	@mkdir_p@ $(DESTDIR)$(iallocatorsdir)
513 7fa52acd Iustin Pop
# FIXME: this is a hardcoded logic, instead of auto-resolving
514 7fa52acd Iustin Pop
	$(LN_S) -f ../../../bin/htools \
515 458a286a Iustin Pop
		   $(DESTDIR)$(iallocatorsdir)/hail
516 201b6c34 Iustin Pop
	for role in $(HS_BIN_ROLES); do \
517 7fa52acd Iustin Pop
		$(LN_S) -f htools \
518 201b6c34 Iustin Pop
			   $(DESTDIR)$(bindir)/$$role ; \
519 201b6c34 Iustin Pop
	done
520 d6159933 Iustin Pop
endif
521 d6159933 Iustin Pop
522 c3f67183 Iustin Pop
$(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
523 16a6192d Iustin Pop
	@if [ -z "$(HTOOLS)" ]; then \
524 16a6192d Iustin Pop
	  echo "Error: htools compilation disabled at configure time" 1>&2 ;\
525 16a6192d Iustin Pop
	  exit 1; \
526 16a6192d Iustin Pop
	fi
527 49e11c49 Iustin Pop
	@BINARY=$(@:htools/%=%); \
528 49e11c49 Iustin Pop
	if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
529 fd0bc853 Iustin Pop
	  echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
530 fd0bc853 Iustin Pop
	  exit 1; \
531 49e11c49 Iustin Pop
	fi
532 a593113c Iustin Pop
	rm -f $(@:htools/%=%).tix
533 49e11c49 Iustin Pop
	BINARY=$(@:htools/%=%); $(GHC) --make \
534 ef958f2a Iustin Pop
	  $(HFLAGS) \
535 1adec4be Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
536 ef958f2a Iustin Pop
	  -osuf $$BINARY.o -hisuf $$BINARY.hi \
537 c7ec3025 Iustin Pop
	  $(HEXTRA) $(HEXTRA_INT) $@
538 d6159933 Iustin Pop
539 b91e9518 Iustin Pop
# for the htools/test binary, we need to enable profiling/coverage
540 c7ec3025 Iustin Pop
htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
541 b91e9518 Iustin Pop
	-fno-warn-monomorphism-restriction -fno-warn-orphans \
542 b91e9518 Iustin Pop
	-fno-warn-missing-methods -fno-warn-unused-imports
543 b91e9518 Iustin Pop
544 896b2850 Iustin Pop
# we compile the hpc-htools binary with the program coverage
545 896b2850 Iustin Pop
htools/hpc-htools: HEXTRA_INT=-fhpc
546 25cdf177 Iustin Pop
547 04d15e63 Iustin Pop
# test dependency
548 896b2850 Iustin Pop
htools/offline-tests.sh: htools/hpc-htools
549 04d15e63 Iustin Pop
550 c7ec3025 Iustin Pop
# rules for building profiling-enabled versions of the haskell
551 c7ec3025 Iustin Pop
# programs: hs-prof does the full two-step build, whereas
552 c7ec3025 Iustin Pop
# hs-prof-quick does only the final rebuild (hs-prof must have been
553 c7ec3025 Iustin Pop
# run before)
554 c7ec3025 Iustin Pop
.PHONY: hs-prof hs-prof-quick
555 c7ec3025 Iustin Pop
hs-prof:
556 c7ec3025 Iustin Pop
	$(MAKE) clean
557 c7ec3025 Iustin Pop
	$(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
558 c7ec3025 Iustin Pop
	rm -f $(HS_ALL_PROGS)
559 c7ec3025 Iustin Pop
	$(MAKE) hs-prof-quick
560 c7ec3025 Iustin Pop
561 c7ec3025 Iustin Pop
hs-prof-quick:
562 c7ec3025 Iustin Pop
	$(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
563 c7ec3025 Iustin Pop
564 da7e44ee Michael Hanselmann
dist_sbin_SCRIPTS = \
565 da7e44ee Michael Hanselmann
	tools/ganeti-listrunner
566 4f3d5b76 Michael Hanselmann
567 fc3fd894 Michael Hanselmann
nodist_sbin_SCRIPTS = \
568 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
569 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner
570 fc3fd894 Michael Hanselmann
571 cc120286 Bernardo Dal Seno
python_scripts = \
572 e8230860 Michael Hanselmann
	tools/burnin \
573 e8230860 Michael Hanselmann
	tools/cfgshell \
574 e8230860 Michael Hanselmann
	tools/cfgupgrade \
575 b5672ea0 Iustin Pop
	tools/cfgupgrade12 \
576 1f7d3f7d René Nussbaumer
	tools/cluster-merge \
577 4ef0399b Iustin Pop
	tools/confd-client \
578 d62cbd3a Michael Hanselmann
	tools/fmtjson \
579 ea5fd476 Iustin Pop
	tools/lvmstrap \
580 6bf273d5 Michael Hanselmann
	tools/move-instance \
581 ced78a66 Agata Murawska
	tools/ovfconverter \
582 05cd934d René Nussbaumer
	tools/setup-ssh \
583 ea5fd476 Iustin Pop
	tools/sanitize-config
584 e8230860 Michael Hanselmann
585 61631293 Stephen Shirley
dist_tools_SCRIPTS = \
586 cc120286 Bernardo Dal Seno
	$(python_scripts) \
587 2f4c951e Stephen Shirley
	tools/kvm-console-wrapper \
588 d9eefcfa Andrea Spadaccini
	tools/xm-console-wrapper \
589 d9eefcfa Andrea Spadaccini
	tools/master-ip-setup
590 61631293 Stephen Shirley
591 2d76b580 Michael Hanselmann
pkglib_python_scripts = \
592 c6ccba7e Michael Hanselmann
	daemons/import-export \
593 c6ccba7e Michael Hanselmann
	tools/check-cert-expired
594 2d76b580 Michael Hanselmann
595 0d2bf835 René Nussbaumer
nodist_pkglib_python_scripts = \
596 0d2bf835 René Nussbaumer
	tools/ensure-dirs
597 0d2bf835 René Nussbaumer
598 b8fe7ca6 Iustin Pop
myexeclib_SCRIPTS = \
599 2d76b580 Michael Hanselmann
	daemons/daemon-util \
600 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
601 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts)
602 f154a7a3 Michael Hanselmann
603 b8fe7ca6 Iustin Pop
nodist_myexeclib_SCRIPTS = \
604 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts)
605 0d2bf835 René Nussbaumer
606 e8230860 Michael Hanselmann
EXTRA_DIST = \
607 e8230860 Michael Hanselmann
	NEWS \
608 7a03d293 Michael Hanselmann
	UPGRADE \
609 f774bd03 Michael Hanselmann
	epydoc.conf.in \
610 70c771f6 Michael Hanselmann
	pylintrc \
611 bb46a96c Michael Hanselmann
	autotools/build-bash-completion \
612 d5a2a550 Michael Hanselmann
	autotools/build-rpc \
613 5d3c30df Michael Hanselmann
	autotools/check-header \
614 eed5c5df Michael Hanselmann
	autotools/check-python-code \
615 f6cbcc06 Michael Hanselmann
	autotools/check-imports \
616 c55cc346 Iustin Pop
	autotools/check-man-dashes \
617 73d0e218 Iustin Pop
	autotools/check-man-warnings \
618 c81ed2b2 Michael Hanselmann
	autotools/check-news \
619 e627fe09 Michael Hanselmann
	autotools/check-tar \
620 96602be4 Michael Hanselmann
	autotools/check-version \
621 d99d1e36 Iustin Pop
	autotools/convert-constants \
622 95eb4188 Michael Hanselmann
	autotools/docpp \
623 27e336af Michael Hanselmann
	autotools/gen-coverage \
624 df69e0a0 Bernardo Dal Seno
	autotools/testrunner \
625 f3313af5 Guido Trotter
	$(RUN_IN_TEMPDIR) \
626 f154a7a3 Michael Hanselmann
	daemons/daemon-util.in \
627 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner.in \
628 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
629 e8230860 Michael Hanselmann
	devel/upload.in \
630 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup.in \
631 b8195800 Iustin Pop
	$(docdot) \
632 f727d134 Michael Hanselmann
	$(docpng) \
633 d17e74b4 Iustin Pop
	$(docrst) \
634 d17e74b4 Iustin Pop
	doc/conf.py \
635 d17e74b4 Iustin Pop
	doc/html \
636 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES:%=%.in) \
637 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default \
638 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default-debug \
639 d6d9ce45 Guido Trotter
	doc/examples/hooks/ethers \
640 89c04c2d Guido Trotter
	doc/examples/gnt-debug/README \
641 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay0.json \
642 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay50.json \
643 e4d452b4 Michael Hanselmann
	test/lockperf.py \
644 e8230860 Michael Hanselmann
	test/testutils.py \
645 e8230860 Michael Hanselmann
	test/mocks.py \
646 e8230860 Michael Hanselmann
	$(dist_TESTS) \
647 e8230860 Michael Hanselmann
	$(TEST_FILES) \
648 6be8e2bf Iustin Pop
	man/footer.rst \
649 6be8e2bf Iustin Pop
	$(manrst) \
650 f727d134 Michael Hanselmann
	$(maninput) \
651 39e0d19e Michael Hanselmann
	qa/qa-sample.json \
652 d6159933 Iustin Pop
	$(qa_scripts) \
653 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
654 5a1e31b4 Iustin Pop
	$(HS_PROG_SRCS) \
655 04d15e63 Iustin Pop
	htools/lint-hints.hs \
656 04d15e63 Iustin Pop
	htools/cli-tests-defs.sh \
657 04d15e63 Iustin Pop
	htools/offline-test.sh
658 e8230860 Michael Hanselmann
659 e8230860 Michael Hanselmann
man_MANS = \
660 e8230860 Michael Hanselmann
	man/ganeti.7 \
661 bae7e531 Michael Hanselmann
	man/ganeti-cleaner.8 \
662 b7b7cda6 Guido Trotter
	man/ganeti-confd.8 \
663 da7e44ee Michael Hanselmann
	man/ganeti-listrunner.8 \
664 320d986d Iustin Pop
	man/ganeti-masterd.8 \
665 e8230860 Michael Hanselmann
	man/ganeti-noded.8 \
666 e8230860 Michael Hanselmann
	man/ganeti-os-interface.7 \
667 320d986d Iustin Pop
	man/ganeti-rapi.8 \
668 e8230860 Michael Hanselmann
	man/ganeti-watcher.8 \
669 e8230860 Michael Hanselmann
	man/gnt-backup.8 \
670 e8230860 Michael Hanselmann
	man/gnt-cluster.8 \
671 d3b4cf9f Iustin Pop
	man/gnt-debug.8 \
672 667dbd6b Adeodato Simo
	man/gnt-group.8 \
673 e8230860 Michael Hanselmann
	man/gnt-instance.8 \
674 d3b4cf9f Iustin Pop
	man/gnt-job.8 \
675 e8230860 Michael Hanselmann
	man/gnt-node.8 \
676 5a19bd35 Iustin Pop
	man/gnt-os.8 \
677 5a19bd35 Iustin Pop
	man/hail.1 \
678 5a19bd35 Iustin Pop
	man/hbal.1 \
679 e2bdaf25 René Nussbaumer
	man/hinfo.1 \
680 5a19bd35 Iustin Pop
	man/hscan.1 \
681 d26d808a Iustin Pop
	man/hspace.1 \
682 d26d808a Iustin Pop
	man/htools.1
683 e8230860 Michael Hanselmann
684 5a19bd35 Iustin Pop
manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
685 6be8e2bf Iustin Pop
manhtml = $(patsubst %.rst,%.html,$(manrst))
686 fcdb582d Michael Hanselmann
mangen = $(patsubst %.rst,%.gen,$(manrst))
687 25c92bc5 Michael Hanselmann
maninput = \
688 5a19bd35 Iustin Pop
	$(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
689 de8eea3e Iustin Pop
	$(patsubst %.html,%.html.in,$(manhtml)) \
690 fcdb582d Michael Hanselmann
	man/footer.man man/footer.html $(mangen)
691 e8230860 Michael Hanselmann
692 e8230860 Michael Hanselmann
TEST_FILES = \
693 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.0.txt \
694 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.3.txt \
695 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-disk.txt \
696 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip4.txt \
697 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip6.txt \
698 27e46076 Michael Hanselmann
	test/data/cert1.pem \
699 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-dummy0.txt \
700 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv4.txt \
701 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv6.txt \
702 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv4.txt \
703 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv6.txt \
704 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline.txt \
705 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo.txt \
706 d816408a Iustin Pop
	test/data/proc_drbd8.txt \
707 a6ac80db Iustin Pop
	test/data/proc_drbd80-emptyline.txt \
708 2d76b580 Michael Hanselmann
	test/data/proc_drbd83.txt \
709 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync.txt \
710 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync_krnl2.6.39.txt \
711 585c8187 Guido Trotter
	test/data/kvm_1.0_help.txt \
712 585c8187 Guido Trotter
	test/data/kvm_0.15.90_help.txt \
713 585c8187 Guido Trotter
	test/data/kvm_0.12.5_help.txt \
714 585c8187 Guido Trotter
	test/data/kvm_0.9.1_help.txt \
715 549071a0 Luca Bigliardi
	test/data/sys_drbd_usermode_helper.txt \
716 6bbd76d2 Iustin Pop
	test/data/htools/hail-alloc-drbd.json \
717 6bbd76d2 Iustin Pop
	test/data/htools/hail-change-group.json \
718 6bbd76d2 Iustin Pop
	test/data/htools/hail-node-evac.json \
719 6bbd76d2 Iustin Pop
	test/data/htools/hail-reloc-drbd.json \
720 9915fb20 Iustin Pop
	test/data/htools/common-suffix.data \
721 9915fb20 Iustin Pop
	test/data/htools/invalid-node.data \
722 9915fb20 Iustin Pop
	test/data/htools/missing-resources.data \
723 55ffacfa Iustin Pop
	test/data/htools/rapi/groups.json \
724 55ffacfa Iustin Pop
	test/data/htools/rapi/info.json \
725 55ffacfa Iustin Pop
	test/data/htools/rapi/instances.json \
726 55ffacfa Iustin Pop
	test/data/htools/rapi/nodes.json \
727 1e6fab60 Agata Murawska
	test/data/ovfdata/compr_disk.vmdk.gz \
728 d92518d3 Agata Murawska
	test/data/ovfdata/config.ini \
729 1e6fab60 Agata Murawska
	test/data/ovfdata/corrupted_resources.ovf \
730 d92518d3 Agata Murawska
	test/data/ovfdata/empty.ini \
731 1e6fab60 Agata Murawska
	test/data/ovfdata/empty.ovf \
732 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.mf \
733 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.ovf \
734 1e6fab60 Agata Murawska
	test/data/ovfdata/gzip_disk.ovf \
735 1e6fab60 Agata Murawska
	test/data/ovfdata/new_disk.vmdk \
736 d92518d3 Agata Murawska
	test/data/ovfdata/no_disk.ini \
737 1e6fab60 Agata Murawska
	test/data/ovfdata/no_disk_in_ref.ovf \
738 d92518d3 Agata Murawska
	test/data/ovfdata/no_os.ini \
739 1e6fab60 Agata Murawska
	test/data/ovfdata/no_ovf.ova \
740 1e6fab60 Agata Murawska
	test/data/ovfdata/ova.ova \
741 1e6fab60 Agata Murawska
	test/data/ovfdata/second_disk.vmdk \
742 d92518d3 Agata Murawska
	test/data/ovfdata/rawdisk.raw \
743 d92518d3 Agata Murawska
	test/data/ovfdata/unsafe_path.ini \
744 1e6fab60 Agata Murawska
	test/data/ovfdata/virtualbox.ovf \
745 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_extension.ovd \
746 d92518d3 Agata Murawska
	test/data/ovfdata/wrong_config.ini \
747 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.mf \
748 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.ovf \
749 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_ova.ova \
750 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_xml.ovf \
751 d92518d3 Agata Murawska
	test/data/ovfdata/other/rawdisk.raw \
752 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.02.txt \
753 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-fail.txt \
754 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-ok.txt \
755 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.02.txt \
756 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.66.txt \
757 2d76b580 Michael Hanselmann
	test/import-export_unittest-helper
758 e8230860 Michael Hanselmann
759 e8c8cf1a Michael Hanselmann
python_tests = \
760 17496050 Guido Trotter
	test/ganeti.asyncnotifier_unittest.py \
761 f942a838 Michael Hanselmann
	test/ganeti.backend_unittest.py \
762 6de7c41d Iustin Pop
	test/ganeti.bdev_unittest.py \
763 6de7c41d Iustin Pop
	test/ganeti.cli_unittest.py \
764 66d1f035 René Nussbaumer
	test/ganeti.client.gnt_cluster_unittest.py \
765 25ce3ec4 Michael Hanselmann
	test/ganeti.client.gnt_instance_unittest.py \
766 1118ec44 Guido Trotter
	test/ganeti.daemon_unittest.py \
767 6de7c41d Iustin Pop
	test/ganeti.cmdlib_unittest.py \
768 cea881e5 Michael Hanselmann
	test/ganeti.compat_unittest.py \
769 edf7d66e Iustin Pop
	test/ganeti.confd.client_unittest.py \
770 e8230860 Michael Hanselmann
	test/ganeti.config_unittest.py \
771 6de7c41d Iustin Pop
	test/ganeti.constants_unittest.py \
772 3bd19c66 Michael Hanselmann
	test/ganeti.errors_unittest.py \
773 e8230860 Michael Hanselmann
	test/ganeti.hooks_unittest.py \
774 ecdf0398 Michael Hanselmann
	test/ganeti.ht_unittest.py \
775 6de7c41d Iustin Pop
	test/ganeti.http_unittest.py \
776 b7d82e40 Iustin Pop
	test/ganeti.hypervisor_unittest.py \
777 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_chroot_unittest.py \
778 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_fake_unittest.py \
779 748e4b5a Michael Hanselmann
	test/ganeti.hypervisor.hv_kvm_unittest.py \
780 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_lxc_unittest.py \
781 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_xen_unittest.py \
782 bb44b1ae Michael Hanselmann
	test/ganeti.impexpd_unittest.py \
783 989a8bee Michael Hanselmann
	test/ganeti.jqueue_unittest.py \
784 e8230860 Michael Hanselmann
	test/ganeti.locking_unittest.py \
785 231db3a5 Michael Hanselmann
	test/ganeti.luxi_unittest.py \
786 033a1d00 Michael Hanselmann
	test/ganeti.masterd.instance_unittest.py \
787 407339d0 Michael Hanselmann
	test/ganeti.mcpu_unittest.py \
788 a744b676 Manuel Franceschini
	test/ganeti.netutils_unittest.py \
789 4c14965f Guido Trotter
	test/ganeti.objects_unittest.py \
790 c32b908e Michael Hanselmann
	test/ganeti.opcodes_unittest.py \
791 1e6fab60 Agata Murawska
	test/ganeti.ovf_unittest.py \
792 a123dc19 Michael Hanselmann
	test/ganeti.qlang_unittest.py \
793 4ca96421 Michael Hanselmann
	test/ganeti.query_unittest.py \
794 cfaeaaf7 Michael Hanselmann
	test/ganeti.rapi.baserlib_unittest.py \
795 95ab4de9 David Knowles
	test/ganeti.rapi.client_unittest.py \
796 4cbd4462 Oleksiy Mishchenko
	test/ganeti.rapi.resources_unittest.py \
797 6395cebb Michael Hanselmann
	test/ganeti.rapi.rlib2_unittest.py \
798 a85f23fa Michael Hanselmann
	test/ganeti.rapi.testutils_unittest.py \
799 33231500 Michael Hanselmann
	test/ganeti.rpc_unittest.py \
800 f12e1736 René Nussbaumer
	test/ganeti.runtime_unittest.py \
801 6de7c41d Iustin Pop
	test/ganeti.serializer_unittest.py \
802 6de7c41d Iustin Pop
	test/ganeti.ssh_unittest.py \
803 048eeb2b Iustin Pop
	test/ganeti.storage_unittest.py \
804 0d2bf835 René Nussbaumer
	test/ganeti.tools.ensure_dirs_unittest.py \
805 93be53da Balazs Lecz
	test/ganeti.uidpool_unittest.py \
806 4fd029cf Michael Hanselmann
	test/ganeti.utils.algo_unittest.py \
807 9d1b963f Michael Hanselmann
	test/ganeti.utils.filelock_unittest.py \
808 f21bb4b7 Michael Hanselmann
	test/ganeti.utils.hash_unittest.py \
809 3865ca48 Michael Hanselmann
	test/ganeti.utils.io_unittest.py \
810 b6fa9a44 Michael Hanselmann
	test/ganeti.utils.log_unittest.py \
811 8dc76d54 Guido Trotter
	test/ganeti.utils.mlock_unittest.py \
812 17b97ab3 Michael Hanselmann
	test/ganeti.utils.nodesetup_unittest.py \
813 a4ccecf6 Michael Hanselmann
	test/ganeti.utils.process_unittest.py \
814 79d22269 Michael Hanselmann
	test/ganeti.utils.retry_unittest.py \
815 7fcffe27 Michael Hanselmann
	test/ganeti.utils.text_unittest.py \
816 7831fc5f Michael Hanselmann
	test/ganeti.utils.wrapper_unittest.py \
817 c50645c0 Michael Hanselmann
	test/ganeti.utils.x509_unittest.py \
818 4fd029cf Michael Hanselmann
	test/ganeti.utils_unittest.py \
819 3f991867 Michael Hanselmann
	test/ganeti.workerpool_unittest.py \
820 aefbe369 Michael Hanselmann
	test/cfgupgrade_unittest.py \
821 055f822b Michael Hanselmann
	test/docs_unittest.py \
822 4fd2660d Michael Hanselmann
	test/pycurl_reset_unittest.py \
823 055f822b Michael Hanselmann
	test/tempfile_fork_unittest.py
824 0d20cc42 Bernardo Dal Seno
if HAS_FAKEROOT
825 0d20cc42 Bernardo Dal Seno
python_tests += test/ganeti.utils.io_unittest-runasroot.py
826 0d20cc42 Bernardo Dal Seno
endif
827 e8230860 Michael Hanselmann
828 b91e9518 Iustin Pop
haskell_tests = htools/test
829 b91e9518 Iustin Pop
830 e8c8cf1a Michael Hanselmann
dist_TESTS = \
831 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
832 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
833 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
834 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
835 e8c8cf1a Michael Hanselmann
	$(python_tests)
836 e8c8cf1a Michael Hanselmann
837 e8230860 Michael Hanselmann
nodist_TESTS =
838 d3cd5a3f Iustin Pop
check_SCRIPTS =
839 d3cd5a3f Iustin Pop
840 e5f6768c Iustin Pop
if WANT_HTOOLSTESTS
841 b91e9518 Iustin Pop
nodist_TESTS += $(haskell_tests)
842 04d15e63 Iustin Pop
dist_TESTS += htools/offline-test.sh
843 896b2850 Iustin Pop
check_SCRIPTS += htools/hpc-htools
844 b91e9518 Iustin Pop
endif
845 e8230860 Michael Hanselmann
846 e8230860 Michael Hanselmann
TESTS = $(dist_TESTS) $(nodist_TESTS)
847 e8230860 Michael Hanselmann
848 27e336af Michael Hanselmann
# Environment for all tests
849 27e336af Michael Hanselmann
PLAIN_TESTS_ENVIRONMENT = \
850 df69e0a0 Bernardo Dal Seno
	PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) \
851 df69e0a0 Bernardo Dal Seno
	FAKEROOT=$(FAKEROOT_PATH) $(RUN_IN_TEMPDIR)
852 27e336af Michael Hanselmann
853 27e336af Michael Hanselmann
# Environment for tests run by automake
854 f848ac00 Michael Hanselmann
TESTS_ENVIRONMENT = \
855 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
856 6e06b36c Iustin Pop
857 eed5c5df Michael Hanselmann
all_python_code = \
858 01a3a718 Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
859 cc120286 Bernardo Dal Seno
	$(python_scripts) \
860 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
861 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts) \
862 e8c8cf1a Michael Hanselmann
	$(python_tests) \
863 01a3a718 Michael Hanselmann
	$(pkgpython_PYTHON) \
864 2d48a3a2 Michael Hanselmann
	$(client_PYTHON) \
865 01a3a718 Michael Hanselmann
	$(hypervisor_PYTHON) \
866 01a3a718 Michael Hanselmann
	$(rapi_PYTHON) \
867 899c4d2c Michael Hanselmann
	$(server_PYTHON) \
868 0d2bf835 René Nussbaumer
	$(pytools_PYTHON) \
869 01a3a718 Michael Hanselmann
	$(http_PYTHON) \
870 01a3a718 Michael Hanselmann
	$(confd_PYTHON) \
871 dc101ecc Michael Hanselmann
	$(masterd_PYTHON) \
872 bb44b1ae Michael Hanselmann
	$(impexpd_PYTHON) \
873 c047a981 Michael Hanselmann
	$(utils_PYTHON) \
874 9f4bb951 Michael Hanselmann
	$(watcher_PYTHON) \
875 a8c68e44 Michael Hanselmann
	$(noinst_PYTHON) \
876 a8c68e44 Michael Hanselmann
	$(qa_scripts)
877 01a3a718 Michael Hanselmann
878 eed5c5df Michael Hanselmann
srclink_files = \
879 6be8e2bf Iustin Pop
	man/footer.rst \
880 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
881 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
882 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
883 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
884 04d15e63 Iustin Pop
	htools/offline-test.sh \
885 d3cd5a3f Iustin Pop
	htools/cli-tests-defs.sh \
886 d6159933 Iustin Pop
	$(all_python_code) \
887 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_PROG_SRCS)
888 eed5c5df Michael Hanselmann
889 eed5c5df Michael Hanselmann
check_python_code = \
890 e4e7c7df Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
891 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
892 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
893 95eb4188 Michael Hanselmann
	$(DOCPP) \
894 eed5c5df Michael Hanselmann
	$(all_python_code)
895 eed5c5df Michael Hanselmann
896 e4e7c7df Michael Hanselmann
lint_python_code = \
897 f60d352e Michael Hanselmann
	ganeti \
898 f1763373 Iustin Pop
	ganeti/http/server.py \
899 f60d352e Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
900 cc120286 Bernardo Dal Seno
	$(python_scripts) \
901 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
902 2cc8bdd0 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
903 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
904 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
905 95eb4188 Michael Hanselmann
	$(DOCPP) \
906 2cc8bdd0 Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
907 eed5c5df Michael Hanselmann
908 f6cbcc06 Michael Hanselmann
standalone_python_modules = \
909 f6cbcc06 Michael Hanselmann
	lib/rapi/client.py \
910 f6cbcc06 Michael Hanselmann
	tools/ganeti-listrunner
911 f6cbcc06 Michael Hanselmann
912 21bf2e2e Andrea Spadaccini
pep8_python_code = \
913 21bf2e2e Andrea Spadaccini
	ganeti \
914 21bf2e2e Andrea Spadaccini
	ganeti/http/server.py \
915 21bf2e2e Andrea Spadaccini
	$(dist_sbin_SCRIPTS) \
916 cc120286 Bernardo Dal Seno
	$(python_scripts) \
917 21bf2e2e Andrea Spadaccini
	$(pkglib_python_scripts) \
918 21bf2e2e Andrea Spadaccini
	$(BUILD_BASH_COMPLETION) \
919 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
920 21bf2e2e Andrea Spadaccini
	$(DOCPP) \
921 21bf2e2e Andrea Spadaccini
	$(PYTHON_BOOTSTRAP) \
922 21bf2e2e Andrea Spadaccini
	qa
923 21bf2e2e Andrea Spadaccini
924 571b34f8 Michael Hanselmann
test/daemon-util_unittest.bash: daemons/daemon-util
925 571b34f8 Michael Hanselmann
926 7172f605 Michael Hanselmann
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
927 7172f605 Michael Hanselmann
928 26916aad Apollon Oikonomopoulos
tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
929 26916aad Apollon Oikonomopoulos
	sed -f $(REPLACE_VARS_SED) < $< > $@
930 26916aad Apollon Oikonomopoulos
	chmod +x $@
931 26916aad Apollon Oikonomopoulos
932 dbefcc7e Michael Hanselmann
devel/upload: devel/upload.in $(REPLACE_VARS_SED)
933 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
934 e8230860 Michael Hanselmann
	chmod u+x $@
935 e8230860 Michael Hanselmann
936 c964d962 Michael Hanselmann
daemons/%: daemons/%.in $(REPLACE_VARS_SED)
937 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
938 5c566e17 Michael Hanselmann
	chmod +x $@
939 e8230860 Michael Hanselmann
940 c964d962 Michael Hanselmann
doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
941 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
942 e8230860 Michael Hanselmann
943 c964d962 Michael Hanselmann
doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
944 a2442bf9 Luca Bigliardi
	sed -f $(REPLACE_VARS_SED) < $< > $@
945 a2442bf9 Luca Bigliardi
946 b959138f Michael Hanselmann
doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
947 88a6ca6f Michael Hanselmann
	lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
948 b959138f Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
949 4f3d5b76 Michael Hanselmann
950 f86e82ef Iustin Pop
doc/%.png: doc/%.dot
951 2ab2b9f5 Iustin Pop
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
952 f86e82ef Iustin Pop
	$(DOT) -Tpng -o $@ $<
953 f86e82ef Iustin Pop
954 de8eea3e Iustin Pop
man/footer.man: man/footer.rst
955 de8eea3e Iustin Pop
	@test -n "$(PANDOC)" || \
956 de8eea3e Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
957 de8eea3e Iustin Pop
	$(PANDOC) -f rst -t man -o $@ $<
958 de8eea3e Iustin Pop
959 6be8e2bf Iustin Pop
man/footer.html: man/footer.rst
960 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
961 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
962 6be8e2bf Iustin Pop
	$(PANDOC) -f rst -t html -o $@ $<
963 6be8e2bf Iustin Pop
964 fcdb582d Michael Hanselmann
man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
965 fcdb582d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
966 fcdb582d Michael Hanselmann
967 5a19bd35 Iustin Pop
man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
968 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
969 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
970 a01dd3c6 Iustin Pop
	set -o pipefail ; \
971 9c45babb Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
972 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t man -A man/footer.man $< | \
973 9c45babb Iustin Pop
	  sed -e 's/\\@/@/g' > $@; \
974 73d0e218 Iustin Pop
	if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
975 c55cc346 Iustin Pop
	$(CHECK_MAN_DASHES) $@; \
976 9c45babb Iustin Pop
	trap - EXIT
977 9c45babb Iustin Pop
978 2ab2b9f5 Iustin Pop
979 fcdb582d Michael Hanselmann
man/%.html.in: man/%.gen man/footer.html
980 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
981 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
982 a01dd3c6 Iustin Pop
	set -o pipefail ; \
983 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t html -A man/footer.html $< | \
984 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
985 6be8e2bf Iustin Pop
986 5a19bd35 Iustin Pop
man/%.1: man/%.1.in $(REPLACE_VARS_SED)
987 5a19bd35 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
988 5a19bd35 Iustin Pop
989 dbefcc7e Michael Hanselmann
man/%.7: man/%.7.in $(REPLACE_VARS_SED)
990 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
991 e8230860 Michael Hanselmann
992 dbefcc7e Michael Hanselmann
man/%.8: man/%.8.in $(REPLACE_VARS_SED)
993 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
994 e8230860 Michael Hanselmann
995 dbefcc7e Michael Hanselmann
man/%.html: man/%.html.in $(REPLACE_VARS_SED)
996 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
997 f29266b4 Iustin Pop
998 75f76703 Michael Hanselmann
epydoc.conf: epydoc.conf.in Makefile
999 75f76703 Michael Hanselmann
	sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
1000 f774bd03 Michael Hanselmann
1001 84a12e40 Iustin Pop
vcs-version:
1002 84a12e40 Iustin Pop
	if test -d .git; then \
1003 84a12e40 Iustin Pop
	  git describe > $@; \
1004 84a12e40 Iustin Pop
	elif test ! -f $@ ; then \
1005 84a12e40 Iustin Pop
	  echo "Cannot auto-generate $@ file"; exit 1; \
1006 84a12e40 Iustin Pop
	fi
1007 84a12e40 Iustin Pop
1008 84a12e40 Iustin Pop
.PHONY: regen-vcs-version
1009 84a12e40 Iustin Pop
regen-vcs-version:
1010 e8230860 Michael Hanselmann
	set -e; \
1011 84a12e40 Iustin Pop
	cd $(srcdir); \
1012 84a12e40 Iustin Pop
	if test -d .git; then \
1013 84a12e40 Iustin Pop
	  rm -f vcs-version; \
1014 84a12e40 Iustin Pop
	  $(MAKE) vcs-version; \
1015 84a12e40 Iustin Pop
	fi
1016 84a12e40 Iustin Pop
1017 d6159933 Iustin Pop
htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
1018 d6159933 Iustin Pop
	set -e; \
1019 d6159933 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1020 d6159933 Iustin Pop
	sed -e "s/%ver%/$$VCSVER/" < $< > $@
1021 d6159933 Iustin Pop
1022 d99d1e36 Iustin Pop
htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1023 ef958f2a Iustin Pop
	lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS) \
1024 ef958f2a Iustin Pop
	| lib/_vcsversion.py
1025 11fd5a86 Iustin Pop
	set -e; \
1026 876f6a5e Iustin Pop
	{ cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1027 d99d1e36 Iustin Pop
1028 13aeae6a Iustin Pop
lib/_autoconf.py: Makefile | lib/.dir
1029 84a12e40 Iustin Pop
	set -e; \
1030 e8230860 Michael Hanselmann
	{ echo '# This file is automatically generated, do not edit!'; \
1031 e8230860 Michael Hanselmann
	  echo '#'; \
1032 67047322 Iustin Pop
	  echo ''; \
1033 67047322 Iustin Pop
	  echo '"""Build-time configuration for Ganeti.'; \
1034 67047322 Iustin Pop
	  echo '';\
1035 67047322 Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1036 67047322 Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1037 67047322 Iustin Pop
	  echo 'not edit by hand).'; \
1038 67047322 Iustin Pop
	  echo ''; \
1039 67047322 Iustin Pop
	  echo '"""'; \
1040 67047322 Iustin Pop
	  echo ''; \
1041 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1042 0a4e7f24 Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1043 0a4e7f24 Iustin Pop
	  echo '# style warnings' ; \
1044 0a4e7f24 Iustin Pop
	  echo ''; \
1045 e8230860 Michael Hanselmann
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1046 e8230860 Michael Hanselmann
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1047 e8230860 Michael Hanselmann
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1048 e8230860 Michael Hanselmann
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1049 e8230860 Michael Hanselmann
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1050 e8230860 Michael Hanselmann
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1051 e8230860 Michael Hanselmann
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1052 e8230860 Michael Hanselmann
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
1053 553bd93f Vitaly Kuznetsov
	  echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1054 e8230860 Michael Hanselmann
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1055 e8230860 Michael Hanselmann
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1056 2f2dbb4b Jun Futagawa
	  echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1057 e8230860 Michael Hanselmann
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1058 e8230860 Michael Hanselmann
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1059 e8230860 Michael Hanselmann
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1060 cb7c0198 Iustin Pop
	  echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1061 4b97f902 Apollon Oikonomopoulos
	  echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1062 4b97f902 Apollon Oikonomopoulos
	  echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1063 e8230860 Michael Hanselmann
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1064 7e2c5b9e Guido Trotter
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
1065 c4dfb0b6 Andrea Spadaccini
	  echo "IP_PATH = '$(IP_PATH)'"; \
1066 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_PATH = '$(SOCAT)'"; \
1067 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1068 e90739d6 Michael Hanselmann
	  echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1069 bea60381 Michael Hanselmann
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1070 bea60381 Michael Hanselmann
	  echo "TOOLSDIR = '$(toolsdir)'"; \
1071 4f3d5b76 Michael Hanselmann
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1072 f154a7a3 Michael Hanselmann
	  echo "PKGLIBDIR = '$(pkglibdir)'"; \
1073 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1074 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1075 551b6283 Iustin Pop
	  echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1076 8b72b05c René Nussbaumer
	  echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1077 f12e1736 René Nussbaumer
	  echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1078 8b72b05c René Nussbaumer
	  echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1079 f12e1736 René Nussbaumer
	  echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1080 8b72b05c René Nussbaumer
	  echo "RAPI_USER = '$(RAPI_USER)'"; \
1081 f12e1736 René Nussbaumer
	  echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1082 f12e1736 René Nussbaumer
	  echo "CONFD_USER = '$(CONFD_USER)'"; \
1083 f12e1736 René Nussbaumer
	  echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1084 f12e1736 René Nussbaumer
	  echo "NODED_USER = '$(NODED_USER)'"; \
1085 03881cb0 René Nussbaumer
	  echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1086 3536c792 Iustin Pop
	  echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1087 a002ed79 Agata Murawska
	  echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1088 e5395072 Iustin Pop
	  if [ "$(HTOOLS)" ]; then \
1089 e5395072 Iustin Pop
	    echo "HTOOLS = True"; \
1090 e5395072 Iustin Pop
	  else \
1091 e5395072 Iustin Pop
	    echo "HTOOLS = False"; \
1092 e5395072 Iustin Pop
	  fi; \
1093 cd8b0072 Iustin Pop
	  echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1094 e8230860 Michael Hanselmann
	} > $@
1095 e8230860 Michael Hanselmann
1096 13aeae6a Iustin Pop
lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1097 13aeae6a Iustin Pop
	set -e; \
1098 13aeae6a Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1099 13aeae6a Iustin Pop
	{ echo '# This file is automatically generated, do not edit!'; \
1100 13aeae6a Iustin Pop
	  echo '#'; \
1101 13aeae6a Iustin Pop
	  echo ''; \
1102 13aeae6a Iustin Pop
	  echo '"""Build-time VCS version number for Ganeti.'; \
1103 13aeae6a Iustin Pop
	  echo '';\
1104 13aeae6a Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1105 13aeae6a Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1106 13aeae6a Iustin Pop
	  echo 'not edit by hand).'; \
1107 13aeae6a Iustin Pop
	  echo ''; \
1108 13aeae6a Iustin Pop
	  echo '"""'; \
1109 13aeae6a Iustin Pop
	  echo ''; \
1110 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1111 13aeae6a Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1112 13aeae6a Iustin Pop
	  echo '# style warnings' ; \
1113 13aeae6a Iustin Pop
	  echo ''; \
1114 13aeae6a Iustin Pop
	  echo "VCS_VERSION = '$$VCSVER'"; \
1115 13aeae6a Iustin Pop
	} > $@
1116 13aeae6a Iustin Pop
1117 96a7481d Michael Hanselmann
lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1118 96a7481d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1119 d5a2a550 Michael Hanselmann
1120 dbefcc7e Michael Hanselmann
$(REPLACE_VARS_SED): Makefile
1121 e8230860 Michael Hanselmann
	set -e; \
1122 e8230860 Michael Hanselmann
	{ echo 's#@PREFIX@#$(prefix)#g'; \
1123 e8230860 Michael Hanselmann
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1124 e8230860 Michael Hanselmann
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1125 7a2ba406 Luca Bigliardi
	  echo 's#@BINDIR@#$(bindir)#g'; \
1126 e8230860 Michael Hanselmann
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
1127 e8230860 Michael Hanselmann
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1128 2f2dbb4b Jun Futagawa
	  echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1129 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1130 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1131 56956bcb Iustin Pop
	  echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1132 56956bcb Iustin Pop
	  echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1133 d3b4cf9f Iustin Pop
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1134 7e1fac25 Michael Hanselmann
	  echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1135 c5159571 Iustin Pop
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1136 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1137 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1138 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1139 0d150c50 René Nussbaumer
	  echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1140 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1141 0d150c50 René Nussbaumer
	  echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1142 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1143 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1144 46a8da3b René Nussbaumer
	  echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1145 cd8b0072 Iustin Pop
	  echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1146 e8230860 Michael Hanselmann
	} > $@
1147 e8230860 Michael Hanselmann
1148 67313146 Michael Hanselmann
# Using deferred evaluation
1149 899c4d2c Michael Hanselmann
daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1150 9f4bb951 Michael Hanselmann
daemons/ganeti-watcher: MODULE = ganeti.watcher
1151 67313146 Michael Hanselmann
scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1152 0d2bf835 René Nussbaumer
tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1153 67313146 Michael Hanselmann
1154 c964d962 Michael Hanselmann
$(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1155 67313146 Michael Hanselmann
	test -n "$(MODULE)" || { echo Missing module; exit 1; }
1156 2d48a3a2 Michael Hanselmann
	set -e; \
1157 d75e738e Michael Hanselmann
	{ echo '#!/usr/bin/python'; \
1158 2d48a3a2 Michael Hanselmann
	  echo '# This file is automatically generated, do not edit!'; \
1159 67313146 Michael Hanselmann
	  echo "# Edit $(MODULE) instead."; \
1160 2d48a3a2 Michael Hanselmann
	  echo; \
1161 67313146 Michael Hanselmann
	  echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1162 2d48a3a2 Michael Hanselmann
	  echo; \
1163 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0103'; \
1164 2d48a3a2 Michael Hanselmann
	  echo '# C0103: Invalid name'; \
1165 2d48a3a2 Michael Hanselmann
	  echo; \
1166 2d48a3a2 Michael Hanselmann
	  echo 'import sys'; \
1167 67313146 Michael Hanselmann
	  echo 'import $(MODULE) as main'; \
1168 2d48a3a2 Michael Hanselmann
	  echo; \
1169 2d48a3a2 Michael Hanselmann
	  echo '# Temporarily alias commands until bash completion'; \
1170 2d48a3a2 Michael Hanselmann
	  echo '# generator is changed'; \
1171 67313146 Michael Hanselmann
	  echo 'if hasattr(main, "commands"):'; \
1172 55766d34 Andrea Spadaccini
	  echo '  commands = main.commands # pylint: disable=E1101'; \
1173 3f42b4f6 Michael Hanselmann
	  echo 'if hasattr(main, "aliases"):'; \
1174 55766d34 Andrea Spadaccini
	  echo '  aliases = main.aliases # pylint: disable=E1101'; \
1175 2d48a3a2 Michael Hanselmann
	  echo; \
1176 2d48a3a2 Michael Hanselmann
	  echo 'if __name__ == "__main__":'; \
1177 67313146 Michael Hanselmann
	  echo '  sys.exit(main.Main())'; \
1178 2d48a3a2 Michael Hanselmann
	} > $@
1179 2d48a3a2 Michael Hanselmann
	chmod u+x $@
1180 2d48a3a2 Michael Hanselmann
1181 e8230860 Michael Hanselmann
# We need to create symlinks because "make distcheck" will not install Python
1182 e8230860 Michael Hanselmann
# files when building.
1183 c964d962 Michael Hanselmann
stamp-srclinks: Makefile | $(all_dirfiles)
1184 e8230860 Michael Hanselmann
	set -e; \
1185 01a3a718 Michael Hanselmann
	for i in $(srclink_files); do \
1186 e8230860 Michael Hanselmann
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1187 e8230860 Michael Hanselmann
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
1188 e8230860 Michael Hanselmann
		fi; \
1189 e8230860 Michael Hanselmann
	done
1190 dd1dfd9a Michael Hanselmann
	touch $@
1191 97a37b3f Michael Hanselmann
1192 9ff7e35c Michael Hanselmann
.PHONY: ganeti
1193 9ff7e35c Michael Hanselmann
ganeti:
1194 01f3e7b1 Iustin Pop
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1195 9ff7e35c Michael Hanselmann
1196 6b997854 Michael Hanselmann
.PHONY: check-dirs
1197 6b997854 Michael Hanselmann
check-dirs: $(BUILT_SOURCES)
1198 0c1103d6 Iustin Pop
	@set -e; \
1199 6b997854 Michael Hanselmann
	find . -type d \( \( -name . \) -o \( \
1200 6b997854 Michael Hanselmann
		-name .git -o \
1201 6b997854 Michael Hanselmann
		-name autom4te.cache \
1202 6b997854 Michael Hanselmann
		\) -prune -o -print \) | { \
1203 6b997854 Michael Hanselmann
		error=; \
1204 6b997854 Michael Hanselmann
		while read dir; do \
1205 6b997854 Michael Hanselmann
			case "$$dir" in \
1206 6b997854 Michael Hanselmann
				$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1207 6b997854 Michael Hanselmann
				*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1208 6b997854 Michael Hanselmann
			esac; \
1209 6b997854 Michael Hanselmann
		done; \
1210 6b997854 Michael Hanselmann
		for dir in $(DIRS); do \
1211 6b997854 Michael Hanselmann
			if ! test -d "$$dir"; then \
1212 6b997854 Michael Hanselmann
				echo "Directory $$dir listed in DIRS does not exist" >&2; \
1213 6b997854 Michael Hanselmann
				error=1; \
1214 6b997854 Michael Hanselmann
			fi \
1215 6b997854 Michael Hanselmann
		done; \
1216 6b997854 Michael Hanselmann
		if test -n "$$error"; then exit 1; else exit 0; fi; \
1217 6b997854 Michael Hanselmann
	}
1218 6b997854 Michael Hanselmann
1219 f6cbcc06 Michael Hanselmann
.PHONY: check-local
1220 f6cbcc06 Michael Hanselmann
check-local: check-dirs $(BUILT_SOURCES)
1221 eed5c5df Michael Hanselmann
	$(CHECK_PYTHON_CODE) $(check_python_code)
1222 5d3c30df Michael Hanselmann
	PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1223 35576615 Michael Hanselmann
	$(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1224 7385c51d Michael Hanselmann
	$(CHECK_NEWS) < $(top_srcdir)/NEWS
1225 83ea5145 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1226 9488fd1d Michael Hanselmann
	expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1227 154d7ba5 Michael Hanselmann
	if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1228 9488fd1d Michael Hanselmann
		echo "Incorrect version in README, expected $$expver"; \
1229 9488fd1d Michael Hanselmann
		exit 1; \
1230 7ecb3d0e Michael Hanselmann
	fi; \
1231 d5114fa1 Michael Hanselmann
	for file in doc/iallocator.rst doc/hooks.rst; do \
1232 d5114fa1 Michael Hanselmann
		if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1233 9822b1dd Iustin Pop
			"Documents Ganeti version $$expver"; then \
1234 d5114fa1 Michael Hanselmann
			echo "Incorrect version in $$file, expected $$expver"; \
1235 d5114fa1 Michael Hanselmann
			exit 1; \
1236 d5114fa1 Michael Hanselmann
		fi; \
1237 d5114fa1 Michael Hanselmann
	done
1238 eed5c5df Michael Hanselmann
1239 49e11c49 Iustin Pop
.PHONY: hs-check
1240 896b2850 Iustin Pop
hs-check: htools/test htools/hpc-htools
1241 49e11c49 Iustin Pop
	@rm -f test.tix
1242 49e11c49 Iustin Pop
	./htools/test
1243 896b2850 Iustin Pop
	HBINARY="./htools/hpc-htools" ./htools/offline-test.sh
1244 49e11c49 Iustin Pop
1245 08366664 Michael Hanselmann
# E111: indentation is not a multiple of four
1246 08366664 Michael Hanselmann
# E261: at least two spaces before inline comment
1247 08366664 Michael Hanselmann
# E501: line too long (80 characters)
1248 08366664 Michael Hanselmann
PEP8_IGNORE = E111,E261,E501
1249 08366664 Michael Hanselmann
1250 08366664 Michael Hanselmann
# For excluding pep8 expects filenames only, not whole paths
1251 08366664 Michael Hanselmann
PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1252 08366664 Michael Hanselmann
1253 e0098923 Iustin Pop
.PHONY: lint
1254 c964d962 Michael Hanselmann
lint: $(BUILT_SOURCES)
1255 6d7cc5ff Michael Hanselmann
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1256 08366664 Michael Hanselmann
	if test -z "$(PEP8)"; then \
1257 08366664 Michael Hanselmann
		echo '"pep8" not found during configure' >&2; \
1258 08366664 Michael Hanselmann
	else \
1259 08366664 Michael Hanselmann
		$(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1260 21bf2e2e Andrea Spadaccini
			$(pep8_python_code); \
1261 08366664 Michael Hanselmann
	fi
1262 6d7cc5ff Michael Hanselmann
	$(PYLINT) $(LINT_OPTS) $(lint_python_code)
1263 3582eef6 Iustin Pop
	cd $(top_srcdir)/qa && \
1264 3582eef6 Iustin Pop
	  PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1265 3582eef6 Iustin Pop
	  --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1266 e0098923 Iustin Pop
1267 191ff68c Iustin Pop
.PHONY: hlint
1268 5a1e31b4 Iustin Pop
hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1269 191ff68c Iustin Pop
	if tty -s; then C="-c"; else C=""; fi; \
1270 3603605a Iustin Pop
	hlint --report=doc/hs-lint.html --cross $$C \
1271 3603605a Iustin Pop
	  --ignore "Use first" \
1272 3603605a Iustin Pop
	  --ignore "Use comparing" \
1273 3603605a Iustin Pop
	  --ignore "Use on" \
1274 3603605a Iustin Pop
	  --ignore "Use Control.Exception.catch" \
1275 3603605a Iustin Pop
	  --ignore "Reduce duplication" \
1276 5a1e31b4 Iustin Pop
	  --hint htools/lint-hints \
1277 3603605a Iustin Pop
	  $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1278 191ff68c Iustin Pop
1279 84a12e40 Iustin Pop
# a dist hook rule for updating the vcs-version file; this is
1280 84a12e40 Iustin Pop
# hardcoded due to where it needs to build the file...
1281 84a12e40 Iustin Pop
dist-hook:
1282 84a12e40 Iustin Pop
	$(MAKE) regen-vcs-version && \
1283 84a12e40 Iustin Pop
	rm -f $(top_distdir)/vcs-version && \
1284 84a12e40 Iustin Pop
	cp -p $(srcdir)/vcs-version $(top_distdir)
1285 84a12e40 Iustin Pop
1286 84a12e40 Iustin Pop
# a distcheck hook rule for catching revision control directories
1287 b6f2e47f Iustin Pop
distcheck-hook:
1288 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1289 c6aa0c42 Michael Hanselmann
		echo "Found revision control files in final archive." 1>&2; \
1290 c6aa0c42 Michael Hanselmann
		exit 1; \
1291 c6aa0c42 Michael Hanselmann
	fi
1292 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*.py[co]' | grep .; then \
1293 c6aa0c42 Michael Hanselmann
		echo "Found Python byte code in final archive." 1>&2; \
1294 c6aa0c42 Michael Hanselmann
		exit 1; \
1295 c6aa0c42 Michael Hanselmann
	fi
1296 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*~' | grep .; then \
1297 c6aa0c42 Michael Hanselmann
		echo "Found backup files in final archive." 1>&2; \
1298 b6f2e47f Iustin Pop
		exit 1; \
1299 b6f2e47f Iustin Pop
	fi
1300 bf0b21da Michael Hanselmann
# Empty files or directories should not be distributed. They can cause
1301 bf0b21da Michael Hanselmann
# unnecessary warnings for packagers. Directories used by automake during
1302 bf0b21da Michael Hanselmann
# distcheck must be excluded.
1303 bf0b21da Michael Hanselmann
	if find $(top_distdir) -empty -and -not \( \
1304 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_build -or \
1305 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_inst \) | grep .; then \
1306 bf0b21da Michael Hanselmann
		echo "Found empty files or directories in final archive." 1>&2; \
1307 bf0b21da Michael Hanselmann
		exit 1; \
1308 bf0b21da Michael Hanselmann
	fi
1309 c7b86f6c Michael Hanselmann
	if test -n "$(BUILD_RELEASE)" && \
1310 c7b86f6c Michael Hanselmann
	   grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1311 c7b86f6c Michael Hanselmann
		echo "Found unreleased version in NEWS." >&2; \
1312 c7b86f6c Michael Hanselmann
		exit 1; \
1313 c7b86f6c Michael Hanselmann
	fi
1314 c7b86f6c Michael Hanselmann
1315 c7b86f6c Michael Hanselmann
# When building a release, stricter checks should be used
1316 e627fe09 Michael Hanselmann
distcheck-release dist-release: export BUILD_RELEASE = 1
1317 c7b86f6c Michael Hanselmann
distcheck-release: distcheck
1318 b6f2e47f Iustin Pop
1319 e627fe09 Michael Hanselmann
dist-release: dist
1320 e627fe09 Michael Hanselmann
	set -e; \
1321 e627fe09 Michael Hanselmann
	for i in $(DIST_ARCHIVES); do \
1322 e627fe09 Michael Hanselmann
		echo -n "Checking $$i ... "; \
1323 e627fe09 Michael Hanselmann
		autotools/check-tar < $$i; \
1324 e627fe09 Michael Hanselmann
		echo OK; \
1325 e627fe09 Michael Hanselmann
	done
1326 e627fe09 Michael Hanselmann
1327 8925faaa Iustin Pop
install-exec-local:
1328 0d93b082 Michael Hanselmann
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1329 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
1330 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/run/ganeti"
1331 e8230860 Michael Hanselmann
1332 c964d962 Michael Hanselmann
# To avoid conflicts between directory names and other targets, a file inside
1333 c964d962 Michael Hanselmann
# the directory is used to ensure its existence.
1334 c964d962 Michael Hanselmann
%.dir:
1335 c964d962 Michael Hanselmann
	@mkdir_p@ $* && touch $@
1336 e8230860 Michael Hanselmann
1337 d128fdb6 Iustin Pop
.PHONY: apidoc
1338 a38bfce5 Iustin Pop
if WANT_HTOOLSAPIDOC
1339 a38bfce5 Iustin Pop
apidoc: py-apidoc hs-apidoc
1340 a38bfce5 Iustin Pop
else
1341 a38bfce5 Iustin Pop
apidoc: py-apidoc
1342 a38bfce5 Iustin Pop
endif
1343 a38bfce5 Iustin Pop
1344 a38bfce5 Iustin Pop
.PHONY: py-apidoc
1345 a38bfce5 Iustin Pop
py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1346 b959138f Michael Hanselmann
	$(RUN_IN_TEMPDIR) epydoc -v \
1347 b959138f Michael Hanselmann
		--conf $(CURDIR)/epydoc.conf \
1348 22c5390d Iustin Pop
		--output $(CURDIR)/$(APIDOC_PY_DIR)
1349 a38bfce5 Iustin Pop
1350 a38bfce5 Iustin Pop
.PHONY: hs-apidoc
1351 c3f67183 Iustin Pop
hs-apidoc: $(HS_BUILT_SRCS)
1352 a38bfce5 Iustin Pop
	@test -n "$(HSCOLOUR)" || \
1353 a38bfce5 Iustin Pop
	    { echo 'HsColour' not found during configure; exit 1; }
1354 a38bfce5 Iustin Pop
	@test -n "$(HADDOCK)" || \
1355 a38bfce5 Iustin Pop
	    { echo 'haddock' not found during configure; exit 1; }
1356 22c5390d Iustin Pop
	rm -rf $(APIDOC_HS_DIR)/*
1357 458a286a Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1358 358a0a8f Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1359 22c5390d Iustin Pop
	$(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1360 82888134 Michael Hanselmann
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1361 358a0a8f Iustin Pop
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1362 a38bfce5 Iustin Pop
	set -e ; \
1363 a38bfce5 Iustin Pop
	cd htools; \
1364 c478f837 Iustin Pop
	if [ "$(HTOOLS_NOCURL)" ]; \
1365 c478f837 Iustin Pop
	then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1366 c478f837 Iustin Pop
	else OPTGHC=""; \
1367 c478f837 Iustin Pop
	fi; \
1368 1adec4be Iustin Pop
	if [ "$(HTOOLS_PARALLEL3)" ]; \
1369 1adec4be Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1370 1adec4be Iustin Pop
	fi; \
1371 606e71d3 Iustin Pop
	RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1372 a38bfce5 Iustin Pop
	for file in $$RELSRCS; do \
1373 a38bfce5 Iustin Pop
		hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1374 22c5390d Iustin Pop
		$(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1375 a38bfce5 Iustin Pop
	done ; \
1376 22c5390d Iustin Pop
	$(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1377 a38bfce5 Iustin Pop
		-t ganeti-htools -p haddock-prologue \
1378 a38bfce5 Iustin Pop
		--source-module="%{MODULE/.//}.html" \
1379 a38bfce5 Iustin Pop
		--source-entity="%{MODULE/.//}.html#%{NAME}" \
1380 c478f837 Iustin Pop
		$$OPTGHC \
1381 c3f67183 Iustin Pop
		$(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1382 d128fdb6 Iustin Pop
1383 13e720f1 Iustin Pop
.PHONY: TAGS
1384 eb732fb5 Michael Hanselmann
TAGS: $(BUILT_SOURCES)
1385 13e720f1 Iustin Pop
	rm -f TAGS
1386 74fa8200 Iustin Pop
	find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1387 74fa8200 Iustin Pop
	  -path './daemons/ganeti-*' -o -path './tools/*' -o \
1388 74fa8200 Iustin Pop
	  -path './qa/*.py' | \
1389 3bb5c580 Iustin Pop
	  etags -l python -
1390 13e720f1 Iustin Pop
1391 27e336af Michael Hanselmann
.PHONY: coverage
1392 b91e9518 Iustin Pop
if WANT_HTOOLS
1393 b91e9518 Iustin Pop
coverage: py-coverage hs-coverage
1394 b91e9518 Iustin Pop
else
1395 b91e9518 Iustin Pop
coverage: py-coverage
1396 b91e9518 Iustin Pop
endif
1397 b91e9518 Iustin Pop
1398 b91e9518 Iustin Pop
.PHONY: py-coverage
1399 b91e9518 Iustin Pop
py-coverage: $(BUILT_SOURCES) $(python_tests)
1400 27e336af Michael Hanselmann
	set -e; \
1401 22c5390d Iustin Pop
	COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1402 22c5390d Iustin Pop
	TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1403 22c5390d Iustin Pop
	HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1404 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1405 e8c8cf1a Michael Hanselmann
	$(python_tests)
1406 27e336af Michael Hanselmann
1407 b91e9518 Iustin Pop
.PHONY: hs-coverage
1408 896b2850 Iustin Pop
hs-coverage: $(haskell_tests) htools/hpc-htools
1409 25cdf177 Iustin Pop
	rm -f *.tix && $(MAKE) hs-check
1410 48f12e73 Iustin Pop
	@mkdir_p@ $(COVERAGE_HS_DIR)
1411 896b2850 Iustin Pop
	hpc combine $(HPCEXCL) test.tix hpc-htools.tix > coverage-htools.tix
1412 896b2850 Iustin Pop
	hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1413 896b2850 Iustin Pop
	hpc report coverage-htools.tix
1414 82888134 Michael Hanselmann
	$(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1415 b91e9518 Iustin Pop
1416 ec8379bd Iustin Pop
# Special "kind-of-QA" target for htools, needs special setup (all
1417 ec8379bd Iustin Pop
# tools compiled with -fhpc)
1418 ec8379bd Iustin Pop
.PHONY: live-test
1419 ec8379bd Iustin Pop
live-test: all
1420 ec8379bd Iustin Pop
	set -e ; \
1421 ec8379bd Iustin Pop
	cd htools; \
1422 82888134 Michael Hanselmann
	rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1423 ec8379bd Iustin Pop
	rm -f *.tix *.mix; \
1424 ec8379bd Iustin Pop
	./live-test.sh; \
1425 c3f67183 Iustin Pop
	hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1426 ec8379bd Iustin Pop
	  --output=live-test.tix ; \
1427 22c5390d Iustin Pop
	@mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1428 22c5390d Iustin Pop
	hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1429 ec8379bd Iustin Pop
		--srcdir=.. $(HPCEXCL) ; \
1430 ec8379bd Iustin Pop
	hpc report --srcdir=.. live-test $(HPCEXCL)
1431 b91e9518 Iustin Pop
1432 b341b9ca Guido Trotter
commit-check: distcheck lint apidoc
1433 b341b9ca Guido Trotter
1434 3baa809c Michael Hanselmann
-include ./Makefile.local
1435 3baa809c Michael Hanselmann
1436 e8230860 Michael Hanselmann
# vim: set noet :